> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Retrieve a refund

GET https://rest.test.zuora.com/v1/refunds/{refundKey}

**Note:** This operation is only available if you have [Invoice Settlement](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement) enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see [Invoice Settlement Enablement and Checklist Guide](https://knowledgecenter.zuora.com/Billing/Billing_and_Payments/Invoice_Settlement/Invoice_Settlement_Migration_Checklist_and_Guide) for more information. 

Retrieves the information about a specific refund.


Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/payments/refunds/get-refund

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `refundKey` (string, required) — The unique ID of a refund or the refund number. For example, 4028905f5a87c0ff015a889e590e00c9.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

## Response

### 200

OK

- `accountId` (string, optional) — The ID of the account associated with this refund. Zuora associates the refund automatically with the account from the associated payment or credit memo.
- `amount` (double, optional) — The total amount of the refund.
- `cancelledOn` (string, optional) — The date and time when the refund was cancelled, in `yyyy-mm-dd hh:mm:ss` format.
- `comment` (string, optional, nullable) — Comments about the refund.
- `createdById` (string, optional) — The ID of the Zuora user who created the refund.
- `createdDate` (string, optional) — The date and time when the refund was created, in `yyyy-mm-dd hh:mm:ss` format. For example, `2017-03-01 15:31:10`.
- `creditMemoId` (string, optional) — The ID of the credit memo that is refunded.
- `financeInformation` (GetRefundTypeFinanceInformation, optional) — Container for the finance information related to the refund.
- `gatewayId` (string, optional) — The ID of the gateway instance that processes the refund.
- `gatewayReconciliationReason` (string, optional) — The reason of gateway reconciliation.
- `gatewayReconciliationStatus` (string, optional) — The status of gateway reconciliation.
- `gatewayResponse` (string, optional) — The message returned from the payment gateway for the refund. This message is gateway-dependent.
- `gatewayResponseCode` (string, optional) — The code returned from the payment gateway for the refund. This code is gateway-dependent.
- `gatewayState` (enum, optional) — The status of the refund in the gateway.
  - Allowed values: `MarkedForSubmission`, `Submitted`, `Settled`, `NotSubmitted`, `FailedToSettle`
- `id` (string, optional) — The ID of the refund.
- `markedForSubmissionOn` (string, optional) — The date and time when a refund was marked and waiting for batch submission to the payment process, in `yyyy-mm-dd hh:mm:ss` format.
- `methodType` (enum, optional) — How an external refund was issued to a customer.
  - Allowed values: `ACH`, `Cash`, `Check`, `CreditCard`, `PayPal`, `WireTransfer`, `DebitCard`, `CreditCardReferenceTransaction`, `BankTransfer`, `Other`
- `number` (string, optional) — The unique identification number of the refund.
- `organizationLabel` (string, optional) — The organization that this object belongs to. Note: This field is available only when the Multi-Org feature is enabled.
- `paymentId` (string, optional) — The ID of the payment that is refunded.
- `paymentMethodId` (string, optional) — The unique ID of the payment method that the customer used to make the refund.
- `paymentMethodSnapshotId` (string, optional) — The unique ID of the payment method snapshot, which is a copy of the particular payment method used in a transaction.
- `payoutId` (string, optional) — The payout ID of the refund from the gateway side.
- `reasonCode` (string, optional) — A code identifying the reason for the transaction.
- `referenceId` (string, optional) — The transaction ID returned by the payment gateway for an electronic refund. Use this field to reconcile refunds between your gateway and Zuora Payments.
- `refundDate` (date, optional) — The date when the refund takes effect, in `yyyy-mm-dd` format. For example, `2017-03-01`.
- `refundTransactionTime` (string, optional) — The date and time when the refund was issued, in `yyyy-mm-dd hh:mm:ss` format.
- `secondRefundReferenceId` (string, optional) — The transaction ID returned by the payment gateway if there is an additional transaction for the refund. Use this field to reconcile payments between your gateway and Zuora Payments.
- `settledOn` (string, optional) — The date and time when the refund was settled in the payment processor, in `yyyy-mm-dd hh:mm:ss` format. This field is used by the Spectrum gateway only and not applicable to other gateways.
- `softDescriptor` (string, optional) — A payment gateway-specific field that maps Zuora to other gateways.
- `softDescriptorPhone` (string, optional) — A payment gateway-specific field that maps Zuora to other gateways.
- `status` (enum, optional) — The status of the refund.
  - Allowed values: `Processed`, `Canceled`, `Error`, `Processing`
- `submittedOn` (string, optional) — The date and time when the refund was submitted, in `yyyy-mm-dd hh:mm:ss` format.
- `success` (boolean, optional) — Returns `true` if the request was processed successfully.
- `type` (enum, optional) — The type of the refund.
  - Allowed values: `External`, `Electronic`
- `updatedById` (string, optional) — The ID of the Zuora user who last updated the refund.
- `updatedDate` (string, optional) — The date and time when the refund was last updated, in `yyyy-mm-dd hh:mm:ss` format. For example, 2017-03-02 15:36:10.
- `IntegrationId__NS` (string, optional) — ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `IntegrationStatus__NS` (string, optional) — Status of the refund's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `Origin__NS` (string, optional) — Origin of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `SyncDate__NS` (string, optional) — Date when the refund was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).
- `SynctoNetSuite__NS` (string, optional) — Specifies whether the refund should be synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265).

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### GetRefundTypeFinanceInformation

Container for the finance information related to the refund.

- `bankAccountAccountingCode` (string, optional) — The accounting code that maps to a bank account in your accounting system.
- `bankAccountAccountingCodeType` (string, optional) — The type of the accounting code that maps to a bank account in your accounting system.
- `transferredToAccounting` (enum, optional) — Whether the refund was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite.
  - Allowed values: `Processing`, `Yes`, `No`, `Error`, `Ignore`
- `unappliedPaymentAccountingCode` (string, optional) — The accounting code for the unapplied payment.
- `unappliedPaymentAccountingCodeType` (string, optional) — The type of the accounting code for the unapplied payment.

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Response**

```json
{
  "accountId": "4028905f5a87c0ff015a87d25ae90025",
  "amount": 4,
  "cancelledOn": null,
  "comment": "Create a refund for unapplied payment.",
  "createdById": "402881e522cf4f9b0122cf5d82860002",
  "createdDate": "2017-03-01 14:46:03",
  "creditMemoId": null,
  "financeInformation": {
    "transferredToAccounting": "No"
  },
  "gatewayId": null,
  "gatewayReconciliationReason": null,
  "gatewayReconciliationStatus": null,
  "gatewayResponse": null,
  "gatewayResponseCode": null,
  "gatewayState": "NotSubmitted",
  "id": "4028905f5a87c0ff015a889e590e00c9",
  "markedForSubmissionOn": null,
  "methodType": "CreditCard",
  "number": "R-00000001",
  "paymentId": "4028905f5a87c0ff015a889ddfb800c0",
  "paymentMethodId": null,
  "paymentMethodSnapshotId": null,
  "payoutId": null,
  "reasonCode": "Standard Refund",
  "referenceId": null,
  "refundDate": "2017-03-01",
  "refundTransactionTime": null,
  "secondRefundReferenceId": null,
  "settledOn": null,
  "softDescriptor": null,
  "softDescriptorPhone": null,
  "status": "Processed",
  "submittedOn": null,
  "success": true,
  "type": "External",
  "updatedById": "402881e522cf4f9b0122cf5d82860002",
  "updatedDate": "2017-03-01 14:46:03"
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/refunds/refundKey"

headers = {"Authorization": "Bearer <token>"}

response = requests.get(url, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/refunds/refundKey';
const options = {method: 'GET', headers: {Authorization: 'Bearer <token>'}};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/refunds/refundKey"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Authorization", "Bearer <token>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/refunds/refundKey")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = 'Bearer <token>'

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://rest.test.zuora.com/v1/refunds/refundKey")
  .header("Authorization", "Bearer <token>")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://rest.test.zuora.com/v1/refunds/refundKey', [
  'headers' => [
    'Authorization' => 'Bearer <token>',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/refunds/refundKey");
var request = new RestRequest(Method.GET);
request.AddHeader("Authorization", "Bearer <token>");
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = ["Authorization": "Bearer <token>"]

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/refunds/refundKey")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```